
if not GuildsterDB then
    GuildsterDB = {}
end

numButtons = 3
buttonHeight = 0

-- Filter Variables
memberFilterLow = 0
memberFilterHigh = 999
updatedFilter = false
searchValue = nil

filterTypes = {
["Questing"] = true,
["Dungeons"] = true,
["Raiding"] = true,
["PvP"] = true,
["RP"] = true,
["Weekends"] = true,
["Weekdays"] = true
}

resultsFound = nil
selection = nil

GDB = {
    sortOption = "name",
    initializedDate = nil
}

function OnDBCreation()
    if GDB.initializedDate == nil then
        print("Guildster - Setting intialization Date")
        GDB.initializedDate = GetCurrentTime()
    end
    print("Guildster - Use /guildster to view the window.")
end

-- Frame Creation
function createGuildsterFrame(self, event, arg1, ...)
    if not frameBG then
        -- Create the Frames!
        local factionGroup = UnitFactionGroup("player");

        frameBG = CreateFrame("Frame", "Guildster", UIParent, "BasicFrameTemplate")
            frameBG:SetPoint("CENTER", UIParent, "CENTER", 0, 80)
            frameBG:SetSize(750,532)
            frameBG:SetScript("OnShow", populateFrame)
            frameBG:SetMovable(true)
            frameBG:EnableMouse(true)
            frameBG:RegisterForDrag("LeftButton")
            frameBG:SetScript("OnDragStart", frameBG.StartMoving)
            frameBG:SetScript("OnDragStop", frameBG.StopMovingOrSizing)
            frameBG:SetScript("OnHide", function(self) 
            sFrame:Hide()
            end)

        local header = frameBG:CreateTexture(nil, "ARTWORK")
        header:SetPoint("TOPLEFT", frameBG, "TOPLEFT")
        header:SetSize(750,20)

        header.title = frameBG:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        header.title:SetText("Guildster")
        header.title:SetPoint("CENTER", header, "CENTER", 0, -1)

        local background = frameBG:CreateTexture(nil, "BACKGROUND")
        background:SetSize(512, 512)
        background:SetPoint("TOPLEFT", header, "BOTTOMLEFT", 2, 0)
        background:SetTexture("Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-AchievementBackground")

        local background2 = frameBG:CreateTexture(nil, "BACKGROUND")
        background2:SetSize(512, 512)
        background2:SetPoint("TOPRIGHT", header, "BOTTOMRIGHT", -2, 0)
        background2:SetTexture("Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-AchievementBackground")
        background2:SetTexCoord(1, 0, 0, 1)

        local reqButton = CreateFrame("Button", "Guildster_Req_Button", frameBG, "UIPanelButtonTemplate")
        reqButton:SetText("Request Membership")
        reqButton:SetPoint("TOPRIGHT", frameBG, "BOTTOMRIGHT")
        reqButton:SetSize(150,24)
        reqButton:SetEnabled(false)
        reqButton:SetScript("OnLoad", function(self) 
            if(IsInGuild()) then
                reqButton:SetEnabled(false)
            end
        end)

        -- Top Filtering Frame
        local filterFrame = CreateFrame("Frame", "Guildster_Filter_Frame", frameBG)
        filterFrame:SetSize(750, 80)
        filterFrame:SetPoint("TOPLEFT", header, "BOTTOMLEFT")
        filterFrame:SetFrameStrata("HIGH")
        
        filterFrame.bg = filterFrame:CreateTexture("nil", "BACKGROUND")
        filterFrame.bg:SetColorTexture(0,0,0,0.2)
        filterFrame.bg:SetSize(750,80)
        filterFrame.bg:SetPoint("TOPLEFT", filterFrame, "TOPLEFT")

        filterFrame.divider = filterFrame:CreateTexture(nil, "ARTWORK")
        filterFrame.divider:SetPoint("TOPLEFT", filterFrame, "BOTTOMLEFT", -2, 2)
        filterFrame.divider:SetWidth(frameBG:GetWidth() -6)
        filterFrame.divider:SetHeight(9)
        filterFrame.divider:SetTexture("Interface\\BankFrame\\HorizShadow")
        filterFrame.divider:SetAlpha(0.3)

        local menuFrame = CreateFrame("Frame", "Guildster_Sort_Frame", UIParent, "UIDropDownMenuTemplate")
        
        local sortMenu = {
            { text = "Sorting Options", isTitle = true},   
            { text = "Name", func = function() buttonClick(compareName) end },   
            { text = "Members", func = function() buttonClick(compareMembers) end },   
            { text = "Achievement Points", func = function() buttonClick(compareAchvs) end },   
            { text = "Date Updated", func = function() buttonClick(compareDates) end },   
            { text = "Close Menu", func = function() menuFrame:Hide() end}   
        }

        local membersSliderLow = CreateFrame("Slider", "Guildster_Members_Slider_Low", filterFrame, "OptionsSliderTemplate")
        membersSliderLow:SetWidth(100)
        membersSliderLow:SetHeight(12)
        membersSliderLow:SetPoint("TOPLEFT", filterFrame, "TOPLEFT", 20, -20)
        membersSliderLow:SetOrientation('HORIZONTAL')
        _G[membersSliderLow:GetName().."Text"]:SetText("Members Filter Low")
        _G[membersSliderLow:GetName().."Low"]:SetText("1")
        _G[membersSliderLow:GetName().."High"]:SetText("999")
        membersSliderLow:Show()
        membersSliderLow:SetMinMaxValues(1,999)
        membersSliderLow:SetScript("OnValueChanged", function(self)
            local value = tonumber(string.format("%.0f", self:GetValue()))
            if(Guildster_Members_Slider_High:GetValue() <= value) then
                Guildster_Members_Slider_High:SetValue(value + 1)
            end
            memberFilterLow =  value
            membersSliderLow.Ebox:SetText(value)
            membersSliderLow.Ebox:ClearFocus()
            sortOptions()
            end)

        membersSliderLow.Ebox = CreateFrame("Editbox", nil, membersSliderLow, "InputBoxTemplate")
        membersSliderLow.Ebox:SetSize(35,30)
        membersSliderLow.Ebox:SetAutoFocus(false)
        membersSliderLow.Ebox:SetNumeric(true)
        membersSliderLow.Ebox:SetPoint("LEFT", 120,0)
        membersSliderLow.Ebox:SetScript("OnEditFocusLost", function(self)
            local value = tonumber(string.format("%.0f", self:GetText()))
            if(Guildster_Members_Slider_High:GetValue() <= value) then
                Guildster_Members_Slider_High:SetValue(value + 1)
            end
            memberFilterLow = value
            membersSliderLow:SetValue(value)
            sortOptions()
        end)

        local membersSliderHigh = CreateFrame("Slider", "Guildster_Members_Slider_High", filterFrame, "OptionsSliderTemplate")
        membersSliderHigh:SetWidth(100)
        membersSliderHigh:SetHeight(12)
        membersSliderHigh:SetPoint("TOP", membersSliderLow, "BOTTOM", 0, -22)
        membersSliderHigh:SetOrientation('HORIZONTAL')
        _G[membersSliderHigh:GetName().."Text"]:SetText("Members Filter High")
        _G[membersSliderHigh:GetName().."Low"]:SetText("1")
        _G[membersSliderHigh:GetName().."High"]:SetText("999")
        membersSliderHigh:Show()
        membersSliderHigh:SetMinMaxValues(1,999)
        membersSliderHigh:SetScript("OnValueChanged", function(self)
            local value = tonumber(string.format("%.0f", self:GetValue()))
            if(Guildster_Members_Slider_Low:GetValue() >= value) then
                Guildster_Members_Slider_Low:SetValue(value - 1)
            end

            memberFilterHigh = value
            membersSliderHigh.Ebox:SetText(value)
            membersSliderHigh.Ebox:ClearFocus()
            sortOptions()
            end)
        
        membersSliderHigh.Ebox = CreateFrame("Editbox", "Guildster_SliderHigh_Box", membersSliderHigh, "InputBoxTemplate")
        membersSliderHigh.Ebox:SetSize(35,30)
        membersSliderHigh.Ebox:SetAutoFocus(false)
        membersSliderHigh.Ebox:SetNumeric(true)
        membersSliderHigh.Ebox:SetPoint("LEFT", 120,0)
        membersSliderHigh.Ebox:SetEnabled(true)
        membersSliderHigh.Ebox:SetScript("OnEditFocusLost", function(self)
            local value = tonumber(string.format("%.0f", self:GetText()))
            if(Guildster_Members_Slider_Low:GetValue() >= value) then
                Guildster_Members_Slider_Low:SetValue(value - 1)
            end
            memberFilterHigh = value
            membersSliderHigh:SetValue(value)
            sortOptions()
        end)

        -- Interests
        filterFrame.interests = filterFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        filterFrame.interests:SetPoint("TOPLEFT", filterFrame, "TOP", -190, -7)
        filterFrame.interests:SetText("Interests")

        filterFrame.intDiv = filterFrame:CreateTexture(nil, "ARTWORK")
        filterFrame.intDiv:SetPoint("TOPLEFT", filterFrame.interests, "BOTTOMLEFT", 0, 0)
        filterFrame.intDiv:SetWidth(200)
        filterFrame.intDiv:SetHeight(6)
        filterFrame.intDiv:SetTexture("Interface\\BankFrame\\HorizShadow")
        filterFrame.intDiv:SetAlpha(0.3)

        filterFrame.questing = CreateFrame("CheckButton", 'gbQd', filterFrame, "UICheckButtonTemplate");
        filterFrame.questing:SetPoint("TOPLEFT", filterFrame.interests, "BOTTOMLEFT", 18, 0);
        filterFrame.questing:SetSize(24,24)
        filterFrame.questing:SetChecked(true)
        _G[filterFrame.questing:GetName().."Text"]:SetText("Questing")
        filterFrame.questing:SetScript("OnClick", function(self)
            local value =  filterFrame.questing:GetChecked()
            filterTypes["Questing"] = value
            sortOptions()
        end)

        filterFrame.dungeons = CreateFrame("CheckButton", 'gbDd', filterFrame, "UICheckButtonTemplate");
        filterFrame.dungeons:SetPoint("LEFT", filterFrame.questing, "RIGHT", 60, 0);
        filterFrame.dungeons:SetSize(24,24)
        filterFrame.dungeons:SetChecked(true)
        _G[filterFrame.dungeons:GetName().."Text"]:SetText("Dungeons")
        filterFrame.dungeons:SetScript("OnClick", function(self)
            local value =  filterFrame.dungeons:GetChecked()
            filterTypes["Dungeons"] = value
            sortOptions()
        end)

        filterFrame.raids = CreateFrame("CheckButton", 'gbRd', filterFrame, "UICheckButtonTemplate");
        filterFrame.raids:SetPoint("TOPLEFT", filterFrame.questing, "BOTTOMLEFT", 0, 6);
        filterFrame.raids:SetSize(24,24)
        filterFrame.raids:SetChecked(true)
        _G[filterFrame.raids:GetName().."Text"]:SetText("Raids")
        filterFrame.raids:SetScript("OnClick", function(self)
            local value =  filterFrame.raids:GetChecked()
            filterTypes["Raiding"] = value
            sortOptions()
        end)

        filterFrame.pvp = CreateFrame("CheckButton", 'gbpvpd', filterFrame, "UICheckButtonTemplate");
        filterFrame.pvp:SetPoint("TOPLEFT", filterFrame.dungeons, "BOTTOMLEFT", 0, 6);
        filterFrame.pvp:SetSize(24,24)
        filterFrame.pvp:SetChecked(true)
        _G[filterFrame.pvp:GetName().."Text"]:SetText("PvP")
        filterFrame.pvp:SetScript("OnClick", function(self)
            local value =  filterFrame.pvp:GetChecked()
            filterTypes["PvP"] = value
            sortOptions()
        end)

        filterFrame.rp = CreateFrame("CheckButton", 'gbrpd', filterFrame, "UICheckButtonTemplate");
        filterFrame.rp:SetPoint("TOPLEFT", filterFrame.raids, "BOTTOMLEFT", 0, 6);
        filterFrame.rp:SetSize(24,24)
        filterFrame.rp:SetChecked(true)
        _G[filterFrame.rp:GetName().."Text"]:SetText("Role Playing")
        filterFrame.rp:SetScript("OnClick", function(self)
            local value =  filterFrame.rp:GetChecked()
            filterTypes["RP"] = value
            sortOptions()
        end)

        -- Availability
        filterFrame.avail = filterFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        filterFrame.avail:SetPoint("TOPLEFT", filterFrame.interests, "TOPRIGHT", 160, 0)
        filterFrame.avail:SetText("Availability")

        filterFrame.availDiv = filterFrame:CreateTexture(nil, "ARTWORK")
        filterFrame.availDiv:SetPoint("TOPLEFT", filterFrame.avail, "BOTTOMLEFT", 0, 0)
        filterFrame.availDiv:SetWidth(200)
        filterFrame.availDiv:SetHeight(6)
        filterFrame.availDiv:SetTexture("Interface\\BankFrame\\HorizShadow")
        filterFrame.availDiv:SetAlpha(0.3)

        filterFrame.days = CreateFrame("CheckButton", 'gbdaysd', filterFrame, "UICheckButtonTemplate");
        filterFrame.days:SetPoint("TOPLEFT", filterFrame.avail, "BOTTOMLEFT", 18,0);
        filterFrame.days:SetSize(24,24)
        filterFrame.days:SetChecked(true)
        _G[filterFrame.days:GetName().."Text"]:SetText("Weekdays")
        filterFrame.days:SetScript("OnClick", function(self)
            local value =  filterFrame.days:GetChecked()
            filterTypes["Weekdays"] = value
            sortOptions()
        end)

        filterFrame.ends = CreateFrame("CheckButton", 'gbendsd', filterFrame, "UICheckButtonTemplate");
        filterFrame.ends:SetPoint("LEFT", filterFrame.days, "RIGHT", 60, 0);
        filterFrame.ends:SetSize(24,24)
        filterFrame.ends:SetChecked(true)
        _G[filterFrame.ends:GetName().."Text"]:SetText("Weekends")
        filterFrame.ends:SetScript("OnClick", function(self)
            local value =  filterFrame.ends:GetChecked()
            filterTypes["Weekends"] = value
            sortOptions()
        end)

        searchBox = CreateFrame("Editbox", "Guildster_Search_Box", filterFrame, "InputBoxTemplate")
        searchBox:SetSize(140,30)
        searchBox:SetAutoFocus(false)
        searchBox:SetPoint("BOTTOMRIGHT", filterFrame, "BOTTOMRIGHT", -158, 6)
        searchBox:SetScript("OnTextChanged", function(self)
            local value = self:GetText()
            searchValue =  value
            sortOptions()
        end)

        sText = searchBox:CreateFontString(nil, "ARTWORK", "GameFontNormal")
        sText:SetPoint("RIGHT", searchBox, "LEFT", -8, 0)
        sText:SetText("Search")

        local sortButton = CreateFrame("Button", "Guildster_Sort_Button", filterFrame, "UIPanelButtonTemplate")
        sortButton:SetSize(120,22)
        sortButton:SetText("Sorting Options")   
        sortButton:SetPoint("BOTTOMRIGHT", filterFrame,"BOTTOMRIGHT", -10, 20)
        sortButton:SetScript("OnEnter", function(self) 
            GameTooltip:SetOwner(self, "ANCHOR_CURSOR"); 
            GameTooltip:ClearLines();
            GameTooltip:SetText("Sort the Guilds by parameters",1,1,.10,1,1);    
            GameTooltip:Show() 
        end)
        sortButton:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
        sortButton:SetScript("OnClick", function() EasyMenu(sortMenu, menuFrame, "cursor", 0 , 0, "MENU") end)

        local guildster_date = CreateFrame("CheckButton", 'Guildster_Date_Filter', filterFrame, "UICheckButtonTemplate");
        guildster_date:SetPoint("BOTTOMLEFT", sortButton, "TOPLEFT", -2, -2);
        guildster_date:SetSize(24,24)
        _G[guildster_date:GetName().."Text"]:SetText("Recently Updated")
        guildster_date:SetScript("OnEnter", function(self) 
            GameTooltip:SetOwner(self, "ANCHOR_CURSOR"); 
            GameTooltip:ClearLines();
            GameTooltip:SetText("Only checks guilds which have been updated recently.",1,1,.10,1,1);    
            GameTooltip:Show() 
        end)
        guildster_date:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
        guildster_date:SetScript("OnClick", function(self)
            local value =  guildster_date:GetChecked()
            updatedFilter = value
            sortOptions()
        end)

        local results = sortButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        results:SetPoint("TOP", sortButton, "BOTTOM", 0, -4)

        local g = CreateFrame("Frame")
        g:SetScript("OnUpdate", function(self)
            if resultsFound ~= nil then
                results:SetText("Found "..resultsFound.." guild(s)")
            else
                results:SetText(nil)
            end
        end)

        sFrame = CreateFrame("Frame")
        sFrame:SetFrameStrata("HIGH")
        sFrame:Hide()
    
        selectTexture = sFrame:CreateTexture(nil, "OVERLAY")
        selectTexture:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
        selectTexture:SetColorTexture(1,0,0,0.1)
        selectTexture:SetSize(528, 100)

        -- ScrollFrame
        gScrollFrame = CreateFrame("ScrollFrame", "Guildster_Content", frameBG, "FauxScrollFrameTemplate")
            gScrollFrame:SetFrameStrata("HIGH")
            gScrollFrame:SetPoint("TOPLEFT", filterFrame, "BOTTOMLEFT", 0, 0)
            gScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
            gScrollFrame:SetScript("OnVerticalScroll",function(self,offset)
                FauxScrollFrame_OnVerticalScroll(self, offset, buttonHeight, populateFrame)
            end)

            buttonHeight = gScrollFrame:GetHeight() / numButtons

        gScrollFrame.buttons = {}
        for i=1,numButtons do
            gScrollFrame.buttons[i] = CreateFrame("Button", "Guildster_Button"..i, gScrollFrame)
            local gButton = gScrollFrame.buttons[i]
            gButton:SetSize(gScrollFrame:GetWidth(), gScrollFrame:GetHeight() / numButtons)
            gButton:SetPoint("TOPLEFT", 4, -(i-1)*gScrollFrame:GetHeight() / numButtons -8)
            gButton:RegisterForClicks("LeftButtonUp", "RightButtonUp");

                gButton.highlightTexture = gButton:CreateTexture(nil, "ARTWORK")
                gButton.highlightTexture:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
                gButton.highlightTexture:SetColorTexture(1,1,0,0.05)
                gButton.highlightTexture:SetPoint("TOPLEFT", gButton, "TOPLEFT", -3, 8)
                gButton.highlightTexture:SetSize(gButton:GetWidth() + 25, gButton:GetHeight())
                gButton.highlightTexture:Hide()

                gButton:SetScript("OnEnter", function(self)
                    gButton.highlightTexture:Show()
                end)
                gButton:SetScript("OnLeave", function(self)
                    gButton.highlightTexture:Hide()
                end)
                gButton:SetScript("OnClick", function(self)
                    gButton.highlightTexture:Hide()
                end)
                
                gButton.nameText = gButton:CreateFontString(nil, "ARTWORK", "GameFontNormalHuge")
                gButton.nameText:SetPoint("TOP", gButton, "TOP", -60, 0)
                gButton.nameText:SetText(nil)

                gButton.membersIcon = gButton:CreateTexture(nil, "ARTWORK")
                gButton.membersIcon:SetSize(20,20)
                gButton.membersIcon:SetPoint("TOPRIGHT", gButton.nameText, "TOPLEFT", -40, 0)
                gButton.membersIcon:SetTexture("Interface\\FriendsFrame\\UI-Toast-ChatInviteIcon")

                gButton.membersText = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
                gButton.membersText:SetPoint("LEFT", gButton.membersIcon, "RIGHT", 2, 0)
                gButton.membersText:SetText(nil)

                gButton.acvIcon = gButton:CreateTexture(nil, "ARTWORK")
                gButton.acvIcon:SetSize(20,20)
                gButton.acvIcon:SetPoint("TOPLEFT", gButton.nameText, "TOPRIGHT", 30, 0)
                gButton.acvIcon:SetTexture("Interface\\AchievementFrame\\UI-Achievement-Guild")
                gButton.acvIcon:SetTexCoord(0.63281250, 0.67187500, 0.13085938, 0.16601563)

                gButton.acvText = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
                gButton.acvText:SetPoint("LEFT", gButton.acvIcon, "RIGHT", 2, 0)
                gButton.acvText:SetText(nil)

                gButton.commentText = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
                gButton.commentText:SetSize(300,100)
                gButton.commentText:SetPoint("TOP", gButton.nameText, "BOTTOM", 0, 0)
                gButton.commentText:SetText(nil)

                -- Tabard Stuff
                gButton.tabardTopper = gButton:CreateTexture(nil, "ARTWORK", nil, 1)
                gButton.tabardTopper:SetPoint("TOPLEFT", gButton, "TOPLEFT", 10, 4)
                gButton.tabardTopper:SetSize(108.8, 27.2)
                gButton.tabardTopper:SetTexture("Interface\\AchievementFrame\\UI-Achievement-RightDDLInset")

                gButton.tabardEmblem = gButton:CreateTexture(nil, "ARTWORK", nil, 2)
                gButton.tabardEmblem:SetPoint("TOPLEFT", gButton.tabardTopper, "BOTTOMLEFT", 13, -2)
                gButton.tabardEmblem:SetSize(80,90)
                if ( factionGroup == "Alliance" ) then
                    gButton.tabardEmblem:SetTexture("Interface\\FriendsFrame\\PlusManz-Alliance")
                else
                    gButton.tabardEmblem:SetTexture("Interface\\FriendsFrame\\PlusManz-Horde")
                end

                gButton.tabard = gButton:CreateTexture(nil, "ARTWORK")
                gButton.tabard:SetPoint("TOPLEFT", gButton.tabardTopper, "BOTTOMLEFT", 9,0)
                gButton.tabard:SetSize(88.5,108)
                gButton.tabard:SetTexture("Interface\\GuildFrame\\GuildInspect-Parts")
                gButton.tabard:SetTexCoord(0.23632813, 0.46679688, 0.70117188, 0.98242188)

                gButton.border = gButton:CreateTexture(nil, "ARTWORK", nil, 3)
                gButton.border:SetPoint("TOPLEFT", gButton.tabardTopper, "BOTTOMLEFT", 9,0)
                gButton.border:SetSize(88.5,108)
                gButton.border:SetTexture("Interface\\GuildFrame\\GuildInspect-Parts")
                gButton.border:SetTexCoord(0.00195313, 0.23242188, 0.70117188, 0.98242188)

                gButton.dateText = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
                gButton.dateText:SetPoint("CENTER", gButton.tabardTopper, "CENTER", 0, 3)
                gButton.dateText:SetText(nil)

                -- Filter Checkbuttons
                -- Interests
                gButton.interests = gButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
                gButton.interests:SetPoint("TOPLEFT", gButton, "TOP", 150, 0)
                gButton.interests:SetText("Interests")

                gButton.intDiv = gButton:CreateTexture(nil, "ARTWORK")
                gButton.intDiv:SetPoint("TOPLEFT", gButton.interests, "BOTTOMLEFT", 0, 0)
                gButton.intDiv:SetWidth(200)
                gButton.intDiv:SetHeight(6)
                gButton.intDiv:SetTexture("Interface\\BankFrame\\HorizShadow")
                gButton.intDiv:SetAlpha(0.3)

                gButton.questing = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
                gButton.questing:SetPoint("TOPLEFT", gButton.interests, "BOTTOMLEFT", 18, -3);
                gButton.questing:SetText("Questing")

                gButton.dungeons = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
                gButton.dungeons:SetPoint("LEFT", gButton.questing, "RIGHT", 60, 0);
                gButton.dungeons:SetText("Dungeons")

                gButton.raids = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
                gButton.raids:SetPoint("TOPLEFT", gButton.questing, "BOTTOMLEFT", 0, -3);
                gButton.raids:SetText("Raids")

                gButton.pvp = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
                gButton.pvp:SetPoint("TOPLEFT", gButton.dungeons, "BOTTOMLEFT", 0, -3);
                gButton.pvp:SetText("PvP")

                gButton.rp = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
                gButton.rp:SetPoint("TOPLEFT", gButton.raids, "BOTTOMLEFT", 0, -3);
                gButton.rp:SetText("Role Playing")

                -- Availability
                gButton.avail = gButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
                gButton.avail:SetPoint("TOPLEFT", gButton.rp, "BOTTOMLEFT", -20, -6)
                gButton.avail:SetText("Availability")

                gButton.availDiv = gButton:CreateTexture(nil, "ARTWORK")
                gButton.availDiv:SetPoint("TOPLEFT", gButton.avail, "BOTTOMLEFT", 0, 0)
                gButton.availDiv:SetWidth(200)
                gButton.availDiv:SetHeight(6)
                gButton.availDiv:SetTexture("Interface\\BankFrame\\HorizShadow")
                gButton.availDiv:SetAlpha(0.3)

                gButton.days = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
                gButton.days:SetPoint("TOPLEFT", gButton.avail, "BOTTOMLEFT", 18,-3);
                gButton.days:SetText("Weekdays")

                gButton.ends = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
                gButton.ends:SetPoint("LEFT", gButton.days, "RIGHT", 60, 0);
                gButton.ends:SetText("Weekends")

                -- Roles
                gButton.roles = gButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
                gButton.roles:SetPoint("TOPLEFT", gButton.days, "BOTTOMLEFT", -20, -6);
                gButton.roles:SetText("Roles")

                gButton.roleDiv = gButton:CreateTexture(nil, "ARTWORK")
                gButton.roleDiv:SetPoint("TOPLEFT", gButton.roles, "BOTTOMLEFT", 0, 0)
                gButton.roleDiv:SetWidth(200)
                gButton.roleDiv:SetHeight(6)
                gButton.roleDiv:SetTexture("Interface\\BankFrame\\HorizShadow")
                gButton.roleDiv:SetAlpha(0.3)

                gButton.healer = gButton:CreateTexture(nil, "ARTWORK", nil, 5)
                gButton.healer:SetPoint("TOP", gButton.roleDiv, "BOTTOM", 0, 2);
                gButton.healer:SetSize(18,18)
                gButton.healer:SetTexture("Interface\\LFGFrame\\LFGRole")
                gButton.healer:SetTexCoord(0.75, 1.0, 0, 1.0)
                gButton.healer:SetAlpha(0)

                gButton.tank = gButton:CreateTexture(nil, "ARTWORK", nil, 5)
                gButton.tank:SetPoint("RIGHT", gButton.healer, "LEFT", -30, 0);
                gButton.tank:SetSize(18,18)
                gButton.tank:SetTexture("Interface\\LFGFrame\\LFGRole")
                gButton.tank:SetTexCoord(0.5, 0.75, 0, 1.0)
                gButton.tank:SetAlpha(0)

                gButton.damage = gButton:CreateTexture(nil, "ARTWORK", nil, 5)
                gButton.damage:SetPoint("LEFT", gButton.healer, "RIGHT", 30, 0);
                gButton.damage:SetSize(18,18)
                gButton.damage:SetTexture("Interface\\LFGFrame\\LFGRole")
                gButton.damage:SetTexCoord(0.25, 0.5, 0, 1.0)
                gButton.damage:SetAlpha(0)

                gButton.divider = gButton:CreateTexture(nil, "ARTWORK")
                gButton.divider:SetPoint("BOTTOMLEFT", gButton, "BOTTOMLEFT", -2, 0)
                gButton.divider:SetWidth(frameBG:GetWidth() -6)
                gButton.divider:SetHeight(9)
                gButton.divider:SetTexture("Interface\\BankFrame\\HorizShadow")
                gButton.divider:SetAlpha(0.3)
        end
    end
    frameBG:Show()
end


local tempDB = {}
local sortedDB = {}

function populateFrame()
    local n = 1
    for k,v in pairs(sortedDB) do
        tempDB[n] = k
        n=n+1
    end
    n = n - 1

    FauxScrollFrame_Update(gScrollFrame, n, numButtons, buttonHeight)
    for index = 1, numButtons do
        local offset = index + FauxScrollFrame_GetOffset(gScrollFrame)
        local gButton = gScrollFrame.buttons[index]
        gButton.index = offset
        if offset<=(n) then
            local tempOffset = sortedDB[tempDB[offset]]
            gButton.nameText:SetText(tempOffset.Name)
            gButton.membersText:SetText(tempOffset.Members)
            gButton.acvText:SetText(tempOffset.AchvPts)
            gButton.commentText:SetText(tempOffset.Comment)
            if(DatePlus30(tempOffset.DateUpdated) ~= "olderThan30") then
                gButton.dateText:SetText("Recently Updated")
            else
                gButton.dateText:SetText(nil)
            end
            -- gButton.dateText:SetText(date("%m-%d-%Y",tempOffset.DateUpdated))
            SetLargeGuildTabardTextures(nil, gButton.tabardEmblem, gButton.tabard, gButton.border, tempOffset.Tabard);

            if(tempOffset.Filters.Questing == true) then
                gButton.questing:Show()
            else
                gButton.questing:Hide()
            end
            if(tempOffset.Filters.Dungeons == true) then
                gButton.dungeons:Show()
            else
                gButton.dungeons:Hide()
            end
            if(tempOffset.Filters.Raiding == true) then
                gButton.raids:Show()
            else
                gButton.raids:Hide()
            end
            if(tempOffset.Filters.PvP == true) then
                gButton.pvp:Show()
            else
                gButton.pvp:Hide()
            end
            if(tempOffset.Filters.RP == true) then
                gButton.rp:Show()
            else
                gButton.rp:Hide()
            end
            if(tempOffset.Filters.Weekdays == true) then
                gButton.days:Show()
            else
                gButton.days:Hide()
            end
            if(tempOffset.Filters.Weekends == true) then
                gButton.ends:Show()
            else
                gButton.ends:Hide()
            end
            if(tempOffset.Filters.Tank == true) then
                gButton.tank:SetAlpha(1)
            else
                gButton.tank:SetAlpha(0)
            end
            if(tempOffset.Filters.Healer == true) then
                gButton.healer:SetAlpha(1)
            else
                gButton.healer:SetAlpha(0)
            end
            if(tempOffset.Filters.Damage == true) then
                gButton.damage:SetAlpha(1)
            else
                gButton.damage:SetAlpha(0)
            end

            -- Highlighting / Selecting
            gScrollFrame:SetScript("OnVerticalScroll",function(self,offset)
                selection = nil
                Guildster_Req_Button:Disable();
                sFrame:Hide()
                FauxScrollFrame_OnVerticalScroll(self, offset, buttonHeight, populateFrame)
            end)
            gButton:SetScript("OnClick", function(self)
                if(selectTexture:IsShown()) then
                    sFrame:Hide()
                    selection = nil
                end
                selectTexture:SetPoint("TOPLEFT", gButton, "TOPLEFT", 0, 4)
                sFrame:Show()
                selection = gButton.nameText:GetText()

                local _, numAppsRemaining = GetNumGuildMembershipRequests();
                if ( selection ~= nil and numAppsRemaining > 0 ) then
                    Guildster_Req_Button:Enable();

                -- Getting the indexes of the items in the list
                    ToggleGuildFrame(2)
                    ToggleGuildFrame(2)
                    local guildIndex = {}
                    local selectedIndex = nil;
                    local numGuilds = GetNumRecruitingGuilds();
                    for i = 1, numGuilds do
                        local name, level, numMembers, achPoints, comment, cached, requestPending = GetRecruitingGuildInfo(i);
                        table.insert(guildIndex, name)
                    end
                    for k,v in pairs(guildIndex) do
                        if(selection == v) then
                            selectedIndex = k
                            break
                        end
                    end
                    SetRecruitingGuildSelection(k)
                else
                    Guildster_Req_Button:Disable();
                end
            end)

            Guildster_Req_Button:SetScript("OnClick", function(self)
            	StaticPopupSpecial_Show(GuildFinderRequestMembershipFrame);
                local name, level = GetRecruitingGuildInfo(GetRecruitingGuildSelection());
                GuildFinderRequestMembershipFrameGuildName:SetText(selection);
                GuildFinderRequestMembershipEditBox:SetText(GetLookingForGuildComment());
            end)

            gButton:Show()
        else
            gButton:Hide()
        end
    end
end



function writeToDB(name, numMembers, achPoints, comment, tabardInfo, filterInfo, dateUpdated)
    GuildsterDB[name] = {
        Name = name,
        Members = numMembers,
        AchvPts = achPoints,
        Comment = comment,
        Tabard = tabardInfo,
        Filters = filterInfo,
        DateUpdated = dateUpdated
    }
end

local function checkForGuilds(self, event, arg1, arg2, arg3, ...)

    OnDBCreation()

    local numGuilds = GetNumRecruitingGuilds(); -- Number of Guilds in the Recruitment Frame

    local newGuilds = 0
    local updatedGuilds = 0
    for i = 1, numGuilds do
            local name, level, numMembers, achPoints, comment, cached, requestPending = GetRecruitingGuildInfo(i);
            local bQuest, bDungeon, bRaid, bPvP, bRP, bWeekdays, bWeekends, bTank, bHealer, bDamage = GetRecruitingGuildSettings(i);
            local filterInfo = {
                Questing = bQuest,
                Dungeons = bDungeon,
                Raiding = bRaid,
                PvP = bPvP,
                RP = bRP,
                Weekdays = bWeekdays,
                Weekends = bWeekends,
                Tank = bTank,
                Healer = bHealer,
                Damage = bDamage
            }
            local tabardInfo = { GetRecruitingGuildTabardInfo(i) };
            local dateUpdated = GetCurrentTime()
            if (GuildsterDB[name]) then --Check if the DB cotains this entry already
                if(GuildsterDB[name].Comment ~= comment or numMembers > GuildsterDB[name].Members) then --Check for difference
                    writeToDB(name, numMembers, achPoints, comment, tabardInfo, filterInfo, dateUpdated)
                    updatedGuilds = updatedGuilds + 1
                else
                    -- Do some stuff eventually if it's "too old"
                end
            else
                writeToDB(name, numMembers, achPoints, comment, tabardInfo, filterInfo, dateUpdated)
                newGuilds = newGuilds+1
            end
        -- end
    end

    if newGuilds > 0 then
        print("Guildster - "..newGuilds.." new guilds listed.")
    end
    if updatedGuilds > 0 then
        print("Guildster - "..updatedGuilds.." guilds updated.")
    end
end

local f = CreateFrame("Frame")
f:RegisterEvent("LF_GUILD_BROWSE_UPDATED")
f:SetScript("OnEvent", checkForGuilds)

function sortOptions()
    if(GDB.sortOption ~= nil) then
		if GDB.sortOption == "name" then
			buttonClick(compareName)
		elseif GDB.sortOption == "members" then
			buttonClick(compareMembers)
		elseif GDB.sortOption == "achievements" then
			buttonClick(compareAchvs)
		elseif GDB.sortOption == "date" then
			buttonClick(compareDates)
		end
	else
		buttonClick(compareName)
	end
end

-- Comparison Sorting
function buttonClick(sortType)
    CreateTempDatabase()
    table.sort(sortedDB, sortType)
    populateFrame()
end

function compareName(a,b)
    GDB.sortOption = "name"
	return a.Name < b.Name
end

function compareMembers(a,b)
    local result = a.Members > b.Members
    if a.Members == b.Members then
        result = a.Name < b.Name
    end
    GDB.sortOption = "members"
    return result
end

function compareAchvs(a,b)
    local result = a.AchvPts > b.AchvPts
    if a.AchvPts == b.AchvPts then
        result = a.Name < b.Name
    end
    GDB.sortOption = "achievements"
    return result
end

function compareDates(a,b)
    local result = a.DateUpdated > b.DateUpdated
    if a.DateUpdated == b.DateUpdated then
        result = a.Name < b.Name
    end
    GDB.sortOption = "date"
    return result
end


function CreateTempDatabase()

    table.wipe(sortedDB)

    local tempFilters = {};
    for k,v in pairs(filterTypes) do
        if(v == true) then
            table.insert(tempFilters, k)
        end
    end

    local u = 0
    for game, value in pairs(GuildsterDB) do
        if string.find(value.Name, IgnoreCase(searchValue)) then
            if value.Members >= memberFilterLow and value.Members <= memberFilterHigh then
                if updatedFilter == true and DatePlus30(value.DateUpdated) ~= "olderThan30" then
                    local pos = 1
                    for k,v in pairs(tempFilters) do
                        if(value.Filters[v] == false) then
                            pos = pos + 1
                            break
                        elseif value.Filters[v] == true and pos == #tempFilters then
                            tempTableInsert(value)
                            u = u + 1 
                        else
                            pos = pos + 1
                        end
                    end
                else
                    local pos = 1
                    for k,v in pairs(tempFilters) do
                        if(value.Filters[v] == false) then
                            pos = pos + 1
                            break
                        elseif value.Filters[v] == true and pos == #tempFilters then
                            tempTableInsert(value)
                            u = u + 1 
                        else
                            pos = pos + 1
                        end
                    end
                end
            else
                -- Bup
            end
        else
            -- Bup2
        end
    end
    resultsFound = u
end

function tempTableInsert(value)
    table.insert(sortedDB, {
        Name = value.Name,
        Members = value.Members,
        AchvPts = value.AchvPts,
        Comment = value.Comment,
        Tabard = value.Tabard,
        Filters = value.Filters,
        DateUpdated = value.DateUpdated
    })
end

function GetCurrentTime()
    local curTime = GetServerTime()
    return curTime
end

function DatePlus30(oldDate)
    if (oldDate + 1209600) < GetServerTime() then
        return "olderThan30"
    end
end

function IgnoreCase(s)
    s = string.gsub(s, "%a", function (c)
        return string.format("[%s%s]", string.lower(c),
        string.upper(c))
    end)
    return s
end

function StartGuildSearch()
    for i=1,10 do
        SetLookingForGuildSettings(i, true)
    end
    for i=1,10 do
        SetLookingForGuildSettings(i, true)
    end

    RequestGuildMembershipList();
end

local z = CreateFrame("Frame")
z:RegisterEvent("PLAYER_LOGIN")
z:SetScript("OnEvent", StartGuildSearch)

SLASH_GUILDSTER1 = '/guildster'
SlashCmdList["GUILDSTER"] = function(msg)
    createGuildsterFrame()
end